<script setup lang="ts">
import { ref, nextTick, onMounted } from "vue";
import type { VForm } from "vuetify/components";

//store
import { useMaterialStore } from "@/stores/material";
import { useStockStore } from "../../stores/checkstock";

//View
import MaterialTable from "./MaterialTable.vue";

const stockStore = useStockStore();
const materialStore = useMaterialStore();
const form = ref(false);
const refForm = ref<VForm | null>(null);
const loading = ref(false);

function onSubmit() {}
function closeDialog() {
  stockStore.addNewMaterialDialog = false;
  nextTick(() => {
    stockStore.editStockItem = Object.assign({}, stockStore.initStockItem);
    materialStore.editMaterial = Object.assign({}, materialStore.initMaterial);
  });
}


async function save() {
  const { valid } = await refForm.value!.validate();
  console.log(valid);
  if (!valid) return;
  await stockStore.addNewMaterial();
  
  closeDialog();

}
onMounted(() => {
  stockStore.initializeItem();
  stockStore.editStockItem = Object.assign({}, stockStore.initStockItem);
});



</script>

<template>
  <div>
    <div class="d-flex align-center justify-center">
      <v-btn @click="stockStore.initializeItem"> Initialize Items </v-btn>
    </div>

    <v-layout>
      <v-col cols="6">
        <v-card title="รายการวัตถุดิบที่มีอยู่ในคลัง">
          <!-- addnewDialog -->
            <div style="height:45px ; padding-right:20px" class="d-flex align-center justify-end">
              <!-- addNewMaterialDialog -->
                <v-dialog v-model="stockStore.addNewMaterialDialog" persistent width="500">
                    <template v-slot:activator="{ props }">
                        <v-btn color="blue-lighten-1" v-bind="props" icon="mdi-plus" size="small"> </v-btn>
                    </template>
                    <v-card>
                      <v-card-title>
                        <span class="text-h5">New Material</span>
                      </v-card-title>
                      <v-card-text>
                        <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                          <v-container>
                            <v-row>
                                <v-col cols="12" sm="12" md="4">
                                   <v-text-field
                                  v-model="stockStore.name"
                                  :readonly="loading"
                                  :rules="[(v) => !!v || 'Field is required']"
                                  class="mb-2"
                                  clearable
                                  label="ชื่อวัตถุดิบ"
                                  :type="'string'"
                                ></v-text-field>
                                </v-col>
                                <v-col cols="12" sm="12" md="4">
                                  <v-text-field
                                  v-model="stockStore.minimum"
                                  :readonly="loading"
                                  :rules="[(v) => !!v || 'Field is required']"
                                  class="mb-2"
                                  :type="'number'"
                                  clearable
                                  label="จำนวนขั้นต่ำ"
                                ></v-text-field>
                                </v-col>
                                <v-col cols="12" sm="12" md="4">
                                  <v-text-field
                                  v-model="stockStore.editStockItem.QOH"
                                  :readonly="loading"
                                  :rules="[(v) => !!v || 'Field is required']"
                                  class="mb-2"
                                  :type="'number'"
                                  clearable
                                  label="จำนวนที่มีอยู่"
                                ></v-text-field>
                                </v-col>
                                <v-col cols="12" sm="12" md="4">
                                  <v-text-field
                                 
                                  
                                  v-model="stockStore.typ"
                                  :readonly="loading"
                                  :rules="[(v) => !!v || 'Field is required']"
                                  :type="'string'"
                                  class="mb-2"
                                  clearable
                                  label="หน่วยเรียก"
                                  single-line
                                ></v-text-field>
                                </v-col>
                                
                                

                            </v-row>
                          </v-container>
                        </v-form>
                        <small>*indicates required field</small>
                      </v-card-text>
                      <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn color="blue-darken-1" variant="text" @click="closeDialog()">
                          Close
                        </v-btn>
                        <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
                      </v-card-actions>
                    </v-card>
                  </v-dialog>
            </div>
          <!-- deleteDialog -->
          <v-dialog v-model="stockStore.dialogDelete" max-width="500px">
            <v-card width="200" >
              <v-card-title class="text-h5"
                >Are you sure you want to delete this item?</v-card-title
              >
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn
                  color="blue-darken-1"
                  variant="text"
                  @click="stockStore.closeDelete"
                  >Cancel</v-btn
                >
                <v-btn
                  color="blue-darken-1"
                  variant="text"
                  @click="stockStore.deleteItemConfirm"
                  >OK</v-btn
                >
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
          <!-- tableStockItem -->
          <v-table fixed-header height="300px" overflow-x="auto">
            <thead>
              <tr>
                <th class="text-left">ID</th>
                <th class="text-left">ชื่อวัตถุดิบ</th>
                <th class="text-left">จำนวนที่มีอยู่</th>
                <th class="text-left">ลบวัตถุดิบ</th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="(item, index) in stockStore.stockItems" :key="index">
                <td>{{ item.id }}</td>
                <td>{{ stockStore.getMaterialName[item.id] }}</td>
                <td width="90%">
                  <v-text-field
                    
                    class="d-flex align-center"
                    style="padding: 0px"
                    variant="outlined"
                    rounded="2"
                    :rules="[(v) => !!v || 'Field is required']"
                    :type="'number'"
                    background-color="primary"
                    v-model="item.QOH"
                    clearable
                  ></v-text-field>
                </td>
                <td>
                  <v-icon icon="mdi-delete-circle" size="large" color="red" @click="stockStore.deleteItem(item)"></v-icon>
                </td>
              </tr>
            </tbody>
          </v-table>
          <div class="d-flex align-center justify-end">
            <v-btn @click="stockStore.updateQOHItems" color="primary">Save</v-btn>
          </div>
        </v-card>
      </v-col>
      <v-col cols="6">
        <div style="height: 300px; overflow-y: auto">
          <material-table></material-table>
        </div>
      </v-col>
    </v-layout>
  </div>
</template>
